<template>
<v-card outlined>
  <v-toolbar flat dense>
    <v-toolbar-title>
      Вход
    </v-toolbar-title>
    <v-spacer></v-spacer>
  </v-toolbar>
  <v-divider></v-divider>
  <v-card-text class="">
    <v-flex v-if="!resettingPassword">
      <v-form
        id="loginForm"
        action="request.path"
        method="POST"
        v-on:submit.prevent="signin"
        >
        <!-- Email field (Login form) -->
        <v-text-field
          label="E-mail"
          type="email"
          name="email"
          v-model="loginform.email"
          required
          ></v-text-field>

        <!-- Password field (Login form) -->
        <v-text-field
          type="password"
          name="password"
          label="Пароль"
          v-model="loginform.password"
          required
          ></v-text-field>

        <v-alert
          :value="$data.errors.signin != ''"
          dismissible
          color="error"
          transition="scale-transition"
          >
          {{ errors.signin }}
        </v-alert>

        <div class="text-xs-center">
          <!-- "Enter" button (Login form) -->
          <!-- @click="submit" -->
          <v-btn
            color="success2"
            :loading="loading"
            :disabled="loading"
            type="submit"
            name="action"
            text
            >
            Войти
            <!-- <v-icon right dark>send</v-icon> -->
          </v-btn>

          <!-- "Forget" button (Login form) -->
          <!-- @click.prevent="forgotPassword" -->
          <v-btn text class="right">Забыл пароль...</v-btn>
        </div>
	    </v-form>

  <!-- "Forgot password" part of Login form -->
  <div v-if="resettingPassword">
    <span class="card-title">Восстановление пароля</span>
    <b>{{ $data.loginform.login }}</b>
    <p>На Ваш email будет отправлен код для восстановления пароля</p>
    <p>Действует 15 минут</p>
    <form
      id="resetPasswordForm"
      action="request.path"
      method="POST"
      v-on:submit.prevent="resetPassword"
      >

      <!-- v-on:click.prevent="sendRestorePasswordToken" -->
      <button
        class="btn waves-effect waves-light"
        style="margin:auto"

        >Получить код
        <!-- <i class="material-icons right">send</i> -->
      </button>

      <!-- Reset code field (Reset form) -->
      <div class="input-field s12">
        <input
          id="resetPasswordCode"
          required
          type="text"
          name="code"
          class="validate"
          >
        <label for="resetPasswordCode">Код безопасности</label>
      </div>

      <!-- New Password field (Reset form) -->
      <div class="input-field s12">
        <input
          id="newpassword"
          required
          v-model="loginform.password"
          type="password"
          name="password"
          autocomplete="new-password"
          class="validate"
          >
        <label for="newpassword">Новый пароль</label>
      </div>

      <!-- "Update password" button (Login form) -->
      <!-- type="submit" -->
      <button
        class="btn waves-effect waves-light"

        name="action"
        >Обновить и войти
        <i class="material-icons right">send</i>
      </button>

      <!-- "Back" to Login form -->
      <button
        class="btn-flat waves-effect waves-teal right"
        @click.prevent="forgotPassword"
        >Назад
      </button>

      <!--     <\!-- Cancel -\-> -->
      <!--     <a -->
      <!--       class="waves-effect waves-teal btn-flat" -->
      <!--       @click.prevent="showNewFacultyBox = !showNewFacultyBox" -->
      <!--       >Отмена</a> -->
		</form>
  </div>
</v-flex>
  </v-card-text>
    </v-card>
</template>


<script>
import API from './api.ts';

export default {
  data: () => ({
    errors: {
      signin: '',
    },
    confirmCode: '',
    lastInvalidCode: '',
    loading: false,
    submit: false,
    lastloginform: {
      email: null,
      password: null,
    },
    loginform: {
      login: '', // can be email (and in future - a phone)
      password: '',
    },
    registrationStep: 1,
    resettingPassword: false,
    signinMsgErr: '',
  }),
  methods: {
    // "Login" button
    async signin() {
      this.$data.errors.signin = '';
      const input = this.$data.loginform;
      // const api = new API({
      //   $store: this.$store,
      // });
      try {
        const res = await API.signin(input.email, input.password);
        this.$store.commit('LOGIN_SUCCESS', res.data);
        const url = '';
        if (typeof document !== 'undefined') {
          url = new URL(document.URL);
        }
        const to = url.searchParams.get('to', '/');
        this.$router.push({ path: to });
      } catch (err) {
        this.$toast(err);
      }
    },
    forgotPassword() {
      const { email } = this.$data.loginform;
      if (login) {
        this.$data.resettingPassword = true;
      } else {
        // Please enter email first
      }
    },
    sendRestorePasswordToken() {
      const api = new API();
      api.graphql({
        query: `mutation restorePassword {
  restorePassword(email: "${this.$data.loginform.login}") {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        // GraphQL "login" mutation OK
        const { data } = response;
        const { errors } = data;
        if (errors) {
          errors.forEach((err) => {
            // err.message
          });
          //
        } else {
          // No errors: email and password were valid!
          const user = data.data.login;
          // console.log(user);
        }
      });
    },
  },
};
</script>
